<template>
  <gl-form-group label-for="group-by-listbox">
    <template #label>
      Group by
      <gl-button variant="link" icon="question-o" aria-label="Help" @click="$emit('help')" />
    </template>
    <gl-collapsible-listbox
      id="group-by-listbox"
      :selected="value"
      :items="$options.groupByOptions"
      @select="$emit('input', $event)"
    />
  </gl-form-group>
</template>

<script>
import GlButton from '@gitlab/ui/src/components/base/button/button.vue';
import GlFormGroup from '@gitlab/ui/src/components/base/form/form_group/form_group.vue';
import GlCollapsibleListbox from '@gitlab/ui/src/components/base/new_dropdowns/listbox/listbox.vue';

/**
 * NOTE: The values here correspond to URL search parameters. Do no change
 * them, otherwise stored links to grouped findings will break.
 */
export const GROUP_BY_COMPONENT = 'component';
export const GROUP_BY_SEVERITY = 'severity';
export const GROUP_BY_FILE_TYPE = 'file-type';
export const GROUP_BY_PAJAMAS_COMPLIANCE = 'pajamas-compliance';
export const GROUP_BY_GROUP = 'group';
export const GROUP_BY_MIGRATION_GUIDE = 'migration-guide';
export const GROUP_BY_FILTER = 'filter';
export const GROUP_BY_EXPLICIT_FILTER = 'filter-explicit';
export const GROUP_BY_MATCHED_TEXT = 'matched-text';
export const GROUP_BY_NOTHING = 'nothing';

export const groupByOptions = [
  {
    value: GROUP_BY_COMPONENT,
    text: 'Component',
  },
  {
    value: GROUP_BY_SEVERITY,
    text: 'Severity',
  },
  {
    value: GROUP_BY_FILE_TYPE,
    text: 'File type',
  },
  {
    value: GROUP_BY_PAJAMAS_COMPLIANCE,
    text: 'Pajamas adoption',
  },
  {
    value: GROUP_BY_GROUP,
    text: 'Group (team)',
  },
  {
    value: GROUP_BY_MATCHED_TEXT,
    text: 'Matched text',
  },
  {
    value: GROUP_BY_MIGRATION_GUIDE,
    text: 'Migration guide',
  },
  {
    value: GROUP_BY_EXPLICIT_FILTER,
    text: 'Custom (by filter)',
  },
  {
    value: GROUP_BY_FILTER,
    text: 'Custom (by expanded filter)',
  },
  {
    value: GROUP_BY_NOTHING,
    text: 'Nothing',
  },
];

export default {
  name: 'GroupBy',
  components: {
    GlButton,
    GlFormGroup,
    GlCollapsibleListbox,
  },
  props: {
    value: {
      type: String,
      required: true,
    },
  },
  groupByOptions,
};
</script>
